#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern const byte[] Chars, Logo;

byte[256] CharColors;

static const byte[] ColorSource = {
    Char_Chaser, 4, Color_Magenta,
    Char_Disturber, 4, Color_Red,
    0xff
};

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}


void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = Color_White;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
    CopyPattern(Char_Space, Pattern_Space, Pattern_Man - Pattern_Space);
    CopyPattern(Char_Chaser, Pattern_Chaser, Pattern_End - Pattern_Chaser);
    CopyPattern(Char_Remain, Pattern_Man, 4);
}


void ClearScreen()
{
    FillMemory(VramBase, VramRowSize * (VramHeight + MarginHeight), Color_White);
}


void Print2x2(ptr<byte> pVram, byte c) 
{
    pVram[0] = c;
    ++c;
    pVram[1] = c;
    ++c;
    pVram[VramRowSize] = c;
    ++c;
    pVram[VramRowSize + 1] = c;
}


// void Erase2x2(ptr<byte> pVram)
// {
//     pVram[0] = Char_Space;
//     pVram[1] = Char_Space;
//     pVram[VramRowSize] = Char_Space;
//     pVram[VramRowSize + 1] = Char_Space;
// }
